/**
 * @license
 * Copyright 2018 Google LLC
 * SPDX-License-Identifier: Apache-2.0
 */
import '@material/mwc-ripple/mwc-ripple.js';
import { BaseElement } from '@material/mwc-base/base-element.js';
import { Ripple } from '@material/mwc-ripple/mwc-ripple.js';
import { RippleHandlers } from '@material/mwc-ripple/ripple-handlers.js';
import { MDCSwitchAdapter } from '@material/switch/deprecated/adapter.js';
import MDCSwitchFoundation from '@material/switch/deprecated/foundation.js';
export declare class SwitchBase extends BaseElement {
    checked: boolean;
    disabled: boolean;
    /** @soyPrefixAttribute */
    ariaLabel: string;
    /** @soyPrefixAttribute */
    ariaLabelledBy: string;
    protected mdcRoot: HTMLElement;
    protected formElement: HTMLInputElement;
    ripple: Promise<Ripple | null>;
    protected shouldRenderRipple: boolean;
    protected mdcFoundation: MDCSwitchFoundation;
    protected changeHandler(e: Event): void;
    protected readonly mdcFoundationClass: typeof MDCSwitchFoundation;
    protected createAdapter(): MDCSwitchAdapter;
    protected rippleHandlers: RippleHandlers;
    protected renderRipple(): import("lit-html").TemplateResult<1> | "";
    focus(): void;
    blur(): void;
    click(): void;
    protected firstUpdated(): void;
    protected render(): import("lit-html").TemplateResult<1>;
    protected handleRippleMouseDown(event: Event): void;
    protected handleRippleTouchStart(event: Event): void;
    protected handleRippleDeactivate(): void;
    protected handleRippleMouseEnter(): void;
    protected handleRippleMouseLeave(): void;
    protected handleRippleFocus(): void;
    protected handleRippleBlur(): void;
}
