/**
 * @license
 * Copyright 2018 Google LLC
 * SPDX-License-Identifier: Apache-2.0
 */
import { BaseElement } from '@material/mwc-base/base-element.js';
import { MDCTabIndicatorAdapter } from '@material/tab-indicator/adapter.js';
import MDCTabIndicatorFoundation from '@material/tab-indicator/foundation.js';
import MDCSlidingTabIndicatorFoundation from '@material/tab-indicator/sliding-foundation.js';
import { PropertyValues } from 'lit';
export declare class TabIndicatorBase extends BaseElement {
    protected mdcFoundation: MDCTabIndicatorFoundation;
    protected get mdcFoundationClass(): typeof MDCSlidingTabIndicatorFoundation;
    protected mdcRoot: HTMLElement;
    protected contentElement: HTMLElement;
    icon: string;
    fade: boolean;
    protected render(): import("lit-html").TemplateResult<1>;
    protected updated(changedProperties: PropertyValues): void;
    protected createAdapter(): MDCTabIndicatorAdapter;
    computeContentClientRect(): DOMRect;
    activate(previousIndicatorClientRect?: DOMRect): void;
    deactivate(): void;
}
